import gamemap
import irrthon
import math
import copy
import data
from random import Random

class character():
	model = None
	
class textures():
	floors = ["moldy cracked cement1.jpg","brass01.jpg","bricks1.jpg","glass05.jpg"]
	walls =  ["brass01.jpg","bricks1.jpg","glass05.jpg","moldy cracked cement1.jpg"]
	
class model_state():
	idle, shooting, melee, unmelee, walking, holstering, unholstering, slinging, unslinging, finishing = range(10)
	
class projectile():
	billboard = None
	speed = None
	vector = None
	damage = None
	
	def __init__(self, bill, spd, vec):
		self.speed = spd
		self.billboard = bill
		self.vector = vec
		self.damage = 25
		
	def setPosition(self, vec):
		self.billboard.setPosition(vec)
	
	def getPosition(self):
		return self.billboard.getPosition()
		
class melee_weapon_def():
	model = None
	filename = None
	damage = None
	
	def __init__(self, mod, name, dam):
		self.filename = name
		self.model = mod
		self.damage = dam
		
class robot_types():
	# robot = [b3dfilename, animdef, melee, hitpoints, damage]
	robots = []
	simple_robot = ["simple robot.b3d", "simple robot.def", "simple robot melee.b3d", 100, 10, 50]
	robots.append(simple_robot)
	hammerbot = ["Hammerbot.b3d", "hammerbot.def","Hammerbotmelee.b3d", 125, 15, 60]
	robots.append(hammerbot)
	#pincher_bot = ["pincherbot.b3d", "pincherbot.def", None , 150, 20, 60]
	#robots.append(pincher_bot)
	simple_robot_extreme = ["simple robot extreme.b3d", "simple robot.def", "simple robot melee.b3d", 175, 25, 70]
	robots.append(simple_robot_extreme)
	hammerbot_steel = ["Hammerbotsteel.b3d", "hammerbot.def","Hammerbotsteelmelee.b3d", 200, 30, 100]
	robots.append(hammerbot_steel)
	mantis = ["Mantis.b3d", "Mantis.def", None , 225, 35, 80]
	robots.append(mantis)
	pincher_botsaw = ["pincherbotsaw.b3d", "pincherbot.def","pincherbotsawmelee.b3d", 250, 40, 80]
	robots.append(pincher_botsaw)
	mantis_black = ["Mantisblack.b3d", "Mantis.def","Mantisblackmelee.b3d", 275, 45, 90]
	robots.append(mantis_black)
	#pincher_botgun = ["pincherbotgun.b3d", "pincherbotgun.def","pincherbotgunmelee.b3d" False]
	#robots.append(pincher_botgun)
	#hammerbot_cat = ["Hammerbotcatapult.b3d", "hammerbotcatapult.def","Hammerbotcatapultmelee.b3d" False]
	#robots.append(hammerbot_cat)
	num = len(robots)

class robot():
	model = None
	location = None
	rotation = None
	awake = None
	state = None
	hitpoints = None
	speed = None
	coord = None
	radius = None
	wake_dist2 = 500.0 * 500.0
	robot_def = None

	def __init__(self, irr, r_def, X, Y):
		self.robot_def = r_def
		self.model = irrthon.model(irr, data.get(r_def[0]), 128)
		self.model.loadAnimDef(data.get(r_def[1]))
		self.location = irrthon.vector3df(X,Y,0)
		self.rotation = irrthon.vector3df(90,0,0)
		self.model.setRotation(self.rotation)
		self.setPosition(self.location)
		self.awake = False
		self.state = model_state.idle
		self.hitpoints = r_def[3]
		self.speed = 1.5
		self.coord = gamemap.coord(0,0)
		self.radius = 30
		
	def setPosition(self, vec):
		self.location = vec
		self.location.Z = 0
		self.model.setLocation(vec)
		
	def getPosition(self):
		return self.location
		
class game():
	irr = None
	testguy = None
	location = irrthon.vector3df(0.0, 0.0, 0.0)
	rotation = irrthon.vector3df(90,0,90)
	#walking = False
	player_state = model_state.idle
	walking_target = irrthon.vector3df(0,0,0)
	walking_speed = 3
	click_node = None
	attack_target = None
	coord = gamemap.coord(0, 0)
	radius = 15
	hair = None
	hitpoints = 1000
	#shooting stuff
	pistol = None
	pistol_armed = True
	melee_armed = False
	melee = None
	melee_damage = 50
	charging = 0
	shoot_dir = None
	#sounds
	laser = None
	powerup = None
	punch = None

	floorpanels = []
	camera_angle = 0
	camera_vert = math.pi / 4
	camera_dist = 180
	camera_loc = irrthon.vector3df(0,0,0)
	camera_target = irrthon.vector3df(0,0,0)
	map_ = None
	tile_size = 100.0
	floor_panel_id = 101
	render_dist = 8
	frame_counter = 0
	fps = 60
	millis = 1000 / 60
	light_node = None
	#mouse
	left_click = False
	middle_click = False
	right_click = False
	mouse_x = 0
	mouse_y = 0
	m_c_x = 0
	m_c_y = 0
	#random number generator
	rand = None
	#robots
	robots = []
	# projectiles
	projectiles = []
	# title screen, etc
	title_screen = True
	win_screen = False
	lose_screen = False
	# level
	level = 1
	arch = None
	arch_coord = None
	health_packs = []
	melee_weapons = []
	
	def __init__(self, wrapper):
		self.irr = wrapper
		self.light_node = self.irr.addLightSceneNode(irrthon.vector3df(0,0,0), 1, 1, 1, 500, -1)
		self.rand = Random()
		self.rand.seed(None)
		self.start_level()
		self.irr.setFont(data.get("fixedsys.png"))
		self.laser = irrthon.sound(self.irr, data.get("laser.wav"))
		self.powerup = irrthon.sound(self.irr, data.get("powerup.wav"))
		self.punch = irrthon.sound(self.irr, data.get("punch123.wav"))
		
	def start_level(self):
		self.map_ = gamemap.gamemap(50, 50, self.tile_size)
		self.map_.generateMap(None)
		self.map_.dump()
		self.coord = self.map_.getStart()
		#print "player starting at", self.coord.X, self.coord.Y
		self.location.X = self.coord.X * self.tile_size
		self.location.Y = self.coord.Y * self.tile_size
		self.arch_coord = self.map_.getStairs()
		#print "exit starting at", self.arch_coord.X, self.arch_coord.Y
		arch_loc = irrthon.vector3df(self.arch_coord.X * self.tile_size,self.arch_coord.Y * self.tile_size,0)
		if(self.arch == None):
			self.arch = irrthon.model(self.irr, data.get("arch.b3d"),4)
		self.arch.setLocation(arch_loc)
		self.arch.setRotation(irrthon.vector3df(90,0,90))
		self.generate_enemies()
		self.generate_health_packs()
		
	def next_level(self):
		#remove panels
		for y in range(self.map_.map_height):
			for x in range(self.map_.map_width):
				if(self.map_.getPanel(x,y)):
					self.map_.panelClear(x,y)
					self.map_.setPanel(x, y,False)
		#print "removing", len(self.robots), "robots"
		for robot in self.robots:
			#print "robot removed"
			robot.model.remove()
		self.robots = []
		for health in self.health_packs:
			health.remove()
		self.health_packs = []
		for m_weapon in self.melee_weapons:
			m_weapon.model.remove()
		self.melee_weapons = []
		del self.map_
		self.level += 1
		self.start_level()
		if(self.level > 20):
			self.win_screen = True
				
		
	def generate_enemies(self):
		for y in range(self.map_.map_height):
			for x in range(self.map_.map_height):
				if( x != self.coord.X or y != self.coord.Y):
					if(self.map_.isReallyInRoom(x, y)):
						if((self.rand.randint(0,15)) == 0):
							tilew = self.map_.tile_size
							max_rob = robot_types.num - 1
							level_rob = 1 + self.level
							if(level_rob > max_rob):
								level_rob = max_rob
							robot_def = robot_types.robots[self.rand.randint(0,level_rob)]
							#robot_def = robot_types.robots[2]
							new_bot = robot(self.irr, robot_def, x * tilew, y * tilew)
							self.robots.append(new_bot)
							new_bot.model.loopAnim("walk")
							#print "added robot"
						
	def generate_health_packs(self):
		for y in range(self.map_.map_height):
			for x in range(self.map_.map_width):
				if(self.map_.isInRoom(x, y)):
					if((self.rand.randint(0,24)) == 0):
						tilew = self.map_.tile_size
						health_pack = irrthon.model(self.irr, data.get("banana crate.b3d"),4)
						health_pack.setLocation(irrthon.vector3df(x * tilew, y * tilew, 0))
						health_pack.setRotation(irrthon.vector3df(90,0,0))
						self.health_packs.append(health_pack)

	def updateCoord(self):
		self.coord.X = int((self.location.X + (self.tile_size / 2.0)) / self.tile_size)
		self.coord.Y = int((self.location.Y + (self.tile_size / 2.0)) / self.tile_size)
			
	def setUpCamera(self):
		upvector = irrthon.vector3df(0, 0, 1)
		self.irr.setCameraUp(upvector)
		
	def XYfromAngle(self, vec, angle):
		vec.X = math.sin(angle)
		vec.Y = math.cos(angle)
		
	def angleFromXY(self, vec):
		return math.atan2(vec.Y, vec.X) * 180 / math.pi
	
	def loadModels(self):
		self.testguy = irrthon.model(self.irr, data.get("LazerJack.b3d"), 4)
		self.testguy.loadAnimDef(data.get("guy.def"))
		rot = irrthon.vector3df(90,0,0)
		self.testguy.setRotation(rot)
		self.hair = irrthon.model(self.irr, data.get("LazerJackhair.b3d"), 4)
		self.hair.attachToB3d(self.testguy, "head")
		self.hair.setRotation(irrthon.vector3df(0,90,0))
		self.hair.setLocation(irrthon.vector3df(0,2.6, .7))
		self.pistol = irrthon.model(self.irr, data.get("pistol.b3d"), 4)
		self.pistol.attachToB3d(self.testguy, "weapon")
		#self.melee = irrthon.model(self.irr, data.get("Hammerbotsteelmelee.b3d"),4)
		#self.melee.attachToB3d(self.testguy, "weaponback")
		self.testguy.loopAnim("idle")

	def loadFloorPanel(self, location, rotation, filename):
		panel = irrthon.floor_node(self.irr, self.floor_panel_id, filename, 100.0)
		panel.setPosition(location)
		panel.setRotation(rotation)
		self.floor_panel_id += 1
		#panel.drop()
		return panel
		
	def handleEvent(self, event):
		irr = self.irr;
		event = irr.typeEvent()
		if(event == irrthon.event_type.key and irr.keyDown()):
			if(self.title_screen):
				self.title_screen = False
			if(self.win_screen or self.lose_screen):
				self.irr.end()
				quit()
			key = irr.getKey()
			if(key == irrthon.key.escape):
				self.irr.end()
				quit()
			elif(key == irrthon.key.space):
				if(self.player_state == model_state.idle or self.player_state == model_state.walking):
					if(self.melee != None):
						if(self.pistol_armed):
							self.player_state = model_state.holstering
							self.testguy.playAnim("holster")
						else:
							self.player_state = model_state.slinging
							self.testguy.playAnim("back")
			#elif(key == irrthon.key.key1):
			#	self.testguy.playAnim("shoot")
			#elif(key == irrthon.key.key2):
			#	self.testguy.playAnim("melee")
			#elif(key == irrthon.key.key3):
			#	self.testguy.playAnim("holster")
			#elif(key == irrthon.key.key4):
			#	self.testguy.playAnim("unholster")
			#elif(key == irrthon.key.key5):
			#	self.testguy.playAnim("back")
			#elif(key == irrthon.key.key6):
			#	self.testguy.playAnim("unback")
			#elif(key == irrthon.key.key7):
			#	self.testguy.playAnim("idle")
		elif(event == irrthon.event_type.mouse):
			mouse_event = irr.mouseEvent()
			self.mouse_x = irr.mouse_x()
			self.mouse_y = irr.mouse_y()
			if(mouse_event == irrthon.mouse_event.left_down):
				self.left_click = True
			elif(mouse_event == irrthon.mouse_event.middle_down):
				self.m_c_x = self.mouse_x
				self.m_c_y = self.mouse_y
				self.middle_click = True
			elif(mouse_event == irrthon.mouse_event.right_down):
				self.right_click = True
			elif(mouse_event == irrthon.mouse_event.left_up):
				self.left_click = False
			elif(mouse_event == irrthon.mouse_event.middle_up):
				self.middle_click = False
			elif(mouse_event == irrthon.mouse_event.right_up):
				self.right_click = False

	def getFloor(self, ray):
		p1 = ray.start
		v1 = ray.end - ray.start
		v1.setLength(1.0)
		p2 = irrthon.vector3df(0,0,0)
		v2 = irrthon.vector3df(0,0,1)
		p = p2 - p1
		dot1 = v2.dotProduct(v1)
		if(dot1 == 0.0):
			return None
		dot2 = v2.dotProduct(p)
		t = dot2 / dot1
		v1.setLength(t)
		result = p1 + v1 
		return result
		
	def updateGame(self):
		# frame counting and speed considerations
		self.frame_counter += 1
		if(self.frame_counter > 100):
			self.fps = self.irr.getFPS()
		if(self.fps < 30):
			self.fps = 30
		self.millis = 1000.0 / self.fps
		self.walking_speed = 180.0 / self.fps
		# handle input
		while(self.irr.nEvents() > 0):
			event = self.irr.typeEvent()
			self.handleEvent(event)
			self.irr.popEvent()
		# show title screen or update game
		if(self.title_screen):
			self.irr.drawImage(data.get("title_screen.png"))
		elif(self.win_screen):
			self.irr.drawImage(data.get("win.png"))
		elif(self.lose_screen):
			self.irr.drawImage(data.get("loser.png"))
		else:
			self.drawText()
			self.updateProjectiles()
			self.updateGuy()
			self.updateRobots()
			self.updateCamera()
			self.updateCoord()
			self.updateMap()
			self.updateLight()
		
	def drawText(self):
		text = "Level " + str(self.level)
		self.irr.drawText( text, 350, 560, 600, 600)
			
	def updateProjectiles(self):
		projectiles_to_remove = []
		for proj in self.projectiles:
			destroyed = False
			proj_pos = proj.getPosition()
			proj_pos.Z = 0
			for robot in self.robots:
				pos = robot.getPosition()
				if(pos.getDistanceFrom(proj_pos) < robot.radius):
					robot.hitpoints -= proj.damage
					self.punch.play()
					location = proj.getPosition()
					proj.billboard.remove()
					#self.projectiles.remove(proj) #TODO: fix this
					projectiles_to_remove.insert(0, self.projectiles.index(proj))
					vec = irrthon.vector3df(0.0, 0.0, -0.3)
					part = irrthon.particle_effect(self.irr, 7, vec, 500, 150, 150, data.get("fire.png"), 180)
					part.setPosition(location)
					part.setLifetime(self.irr,100)
					destroyed = True
			if(destroyed == False):
				X = int((proj_pos.X + (self.tile_size / 2.0)) / self.tile_size)
				Y = int((proj_pos.Y + (self.tile_size / 2.0)) / self.tile_size)
				if(self.map_.getTile(X,Y).tile_ == gamemap.tile_type.closed):
					location = proj.getPosition()
					proj.billboard.remove()
					#self.projectiles.remove(proj) #TODO: fix this
					projectiles_to_remove.insert(0, self.projectiles.index(proj))
					vec = irrthon.vector3df(0.0, 0.0, -0.3)
					part = irrthon.particle_effect(self.irr, 7, vec, 500, 150, 150, data.get("fire.png"), 180)
					part.setPosition(location)
					part.setLifetime(self.irr,100)
					destroyed = True
			if(destroyed == False):
				pos = proj.getPosition()
				vec = proj.vector
				vec.setLength(proj.speed * (60.0 / self.fps))
				pos += vec
				proj.setPosition(pos)
		for proj in projectiles_to_remove:
			self.projectiles.pop(proj)

				
	def updateLight(self):
		#self.light_node.setPosition(self.location + irrthon.vector3df(0,0,75))
		self.light_node.setPosition(self.camera_loc)
		
	def updateCamera(self):
		#mouse rotation
		if(self.middle_click == True):
			diff = self.m_c_x - self.mouse_x
			diff *= .008
			self.camera_angle -= diff
			self.m_c_x = self.mouse_x
			
		#vert angle & dist
		target_vert = (math.pi / 2.0) - .2
		target_dist = 260
		if(self.map_.isInRoom(self.coord.X, self.coord.Y)):
			target_vert = math.pi / 4.0
			target_dist = 200
		diff = target_vert - self.camera_vert
		diff *= .05
		self.camera_vert += diff
		diff = target_dist - self.camera_dist
		diff *= .05
		self.camera_dist += diff
		target = irrthon.vector3df(0,0,0)
		target += self.location
		camera = irrthon.vector3df(0,0,0)
		self.XYfromAngle(camera, self.camera_angle)
		w = math.cos(self.camera_vert)
		h = math.sin(self.camera_vert)
		camera.X *= w
		camera.Y *= w
		camera.Z = h
		camera.setLength(self.camera_dist)
		camera += self.location
		self.irr.setCameraLoc(camera, target)
		self.camera_loc = camera
		self.camera_target = target
		
	def updateMap(self):
		dist = self.render_dist
		start_x = self.coord.X - dist
		start_y = self.coord.Y - dist
		length = dist * 2 + 1
		for y in range(length):
			for x in range(length):
				X = x + start_x
				Y = y + start_y
				if(X >= 0 and Y >= 0 and X < self.map_.map_width and Y < self.map_.map_height):
					self.activatePanel(X, Y)
		#check a panel
		y = self.frame_counter % self.map_.map_height
		for x in range(self.map_.map_width):		
			if(x < (self.coord.X - dist) or x > (self.coord.X + dist) or y < (self.coord.Y - dist) or y > (self.coord.Y + dist)):
				if(self.map_.getPanel(x,y)):
					self.map_.panelClear(x,y)
					self.map_.setPanel(x, y,False)
				
	def activatePanel(self, x, y):
		tile = self.map_.getTile(x, y)
		size = self.tile_size
		if(tile.bPanel == False):
			self.map_.setPanel(x,y,True)
			if(tile.tile_ == gamemap.tile_type.floor):
				loc = irrthon.vector3df(x * size, y * size, 0.0)
				rot = irrthon.vector3df(0.0, 0.0, 0.0)
				panel = self.loadFloorPanel(loc,rot, data.get(textures.floors[tile.style]))
				self.map_.panelAppend(x,y, panel)
			elif(tile.tile_ == gamemap.tile_type.closed):
				# ceiling
				loc = irrthon.vector3df(x * size, y * size, size)
				rot = irrthon.vector3df(0.0, 0.0, 0.0)
				panel = self.loadFloorPanel(loc,rot, data.get(textures.walls[tile.style]))
				self.map_.panelAppend(x,y, panel)
				# east face
				if(x < (self.map_.map_width - 1) and self.map_.getTile(x + 1, y).tile_ != gamemap.tile_type.closed):
					loc = irrthon.vector3df( (x + 0.5) * size, y * size, size / 2)
					rot = irrthon.vector3df(0.0, 90, 0.0)
					panel = self.loadFloorPanel(loc,rot, data.get(textures.walls[tile.style]))
					self.map_.panelAppend(x,y, panel)
				# west face
				if(x > 0 and self.map_.getTile(x - 1, y).tile_ != gamemap.tile_type.closed):
					loc = irrthon.vector3df( (x - 0.5) * size, y * size, size / 2)
					rot = irrthon.vector3df(0.0, -90, 0.0)
					panel = self.loadFloorPanel(loc,rot, data.get(textures.walls[tile.style]))
					self.map_.panelAppend(x,y, panel)
				# south face
				if(y < (self.map_.map_height - 1) and self.map_.getTile(x, y + 1).tile_ != gamemap.tile_type.closed):
					loc = irrthon.vector3df( x * size, (y + 0.5) * size, size / 2)
					rot = irrthon.vector3df(-90, 0.0, 0.0)
					panel = self.loadFloorPanel(loc,rot, data.get(textures.walls[tile.style]))
					self.map_.panelAppend(x,y, panel)
				# north face
				if(y > 0 and self.map_.getTile(x, y - 1).tile_ != gamemap.tile_type.closed):
					loc = irrthon.vector3df( x * size, (y - 0.5) * size, size / 2)
					rot = irrthon.vector3df(90, 0.0, 0.0)
					panel = self.loadFloorPanel(loc,rot, data.get(textures.walls[tile.style]))
					self.map_.panelAppend(x,y, panel)
					
	def updateGuy(self):
		#draw health bar
		self.irr.drawRect(128,128,128,128, 10,10,20,590)
		y_pos = 590 - (580 * self.hitpoints) / 1000
		self.irr.drawRect(128, 0, 128, 0, 10, y_pos, 20,590)
		if(self.hitpoints <= 0):
			self.lose_screen = True
		if(self.right_click and (self.player_state == model_state.walking or self.player_state == model_state.idle)):
			ray = self.irr.getRay(self.mouse_x, self.mouse_y)
			target = self.getFloor(ray)
			if(target != None):
				#print "You clicked on:", target.X, target.Y, target.Z
				self.walking_target = target
				if(self.player_state != model_state.walking):
					self.testguy.loopAnim("walk")
				self.player_state = model_state.walking
				#self.walking = True
				go_vector = target - self.location
				go_vector.Z = 0
				go_vector.setLength(1.0)
				angle = self.angleFromXY(go_vector)
				self.rotation.Z = angle + 90
		if(self.left_click and(self.player_state == model_state.idle or self.player_state == model_state.walking)):
			self.click_node = self.irr.getSceneNode(self.mouse_x, self.mouse_y, 128)
			self.attack_target = None
			for robot in self.robots:
				if(robot.model.isNode(self.click_node)):
					self.attack_target = robot
			if(self.attack_target != None):
				direction = self.attack_target.getPosition() - self.location
				direction.Z = 0.0
				direction.setLength(1.0)
				angle = self.angleFromXY(direction)
				self.rotation.Z = angle + 90
				if(self.pistol_armed):				
					self.testguy.playAnim("shoot")
					self.player_state = model_state.shooting
					#create projectile
					self.charging = 3
					self.shoot_dir = direction
				else:
					self.testguy.playAnim("melee")
					self.player_state = model_state.melee
		
		if(self.charging > 0):
			self.charging -= 1
			if(self.charging <= 0):
				self.laser.play()
				billboard = irrthon.billboard(self.irr, 20, data.get("fire.png"))
				billboard.setPosition(self.pistol.getB3DNodeLoc("fire"))
				vec = irrthon.vector3df(0.0, 0.0, -0.1)
				part = irrthon.particle_effect(self.irr, 14, vec, 100, 300, 500, data.get("smoke.png"), 30)
				part.attachToBillboard(billboard)
				proj = projectile(billboard, 10.0, self.shoot_dir)
				self.projectiles.append(proj)
		
		if(self.player_state == model_state.shooting):
			if(self.testguy.isAnimDone()):
				self.player_state = model_state.idle
		elif(self.player_state == model_state.melee):
			if(self.testguy.isAnimHalfDone()):
				#test for hit
				for robot in self.robots:
					vec = robot.getPosition() - self.location
					distance = vec.getLength()
					vec.setLength(1.0)
					if(distance < (robot.radius + self.radius + 25)):
						player_vec = irrthon.vector3df(0,0,0)
						self.XYfromAngle(player_vec, (-self.rotation.Z + 180) * (math.pi / 180.0))
						if(player_vec.dotProduct(vec) > .707):
							robot.hitpoints -= self.melee_damage
							self.punch.play()
				self.player_state = model_state.unmelee
		elif(self.player_state == model_state.unmelee):
			if(self.testguy.isAnimDone()):
				self.player_state = model_state.idle
				self.testguy.loopAnim("idle")
				
		if(self.player_state == model_state.holstering):
			if(self.testguy.isAnimDone()):
				if(self.pistol_armed):
					self.pistol.attachToB3d(self.testguy, "weaponhip")
					self.pistol_armed = False
					self.player_state = model_state.unholstering
					self.testguy.playAnim("unholster")
				else:
					self.pistol.attachToB3d(self.testguy, "weapon")
					self.pistol_armed = True
					self.player_state = model_state.unholstering
					self.testguy.playAnim("unholster")
		elif(self.player_state == model_state.unholstering):
			if(self.testguy.isAnimDone()):
				if(self.pistol_armed):
					self.player_state = model_state.idle
					self.testguy.loopAnim("idle")
				else:
					self.player_state = model_state.slinging
					self.testguy.playAnim("back")
		elif(self.player_state == model_state.slinging):
			if(self.testguy.isAnimDone()):
				if(self.melee_armed):
					self.player_state = model_state.unslinging
					self.melee.attachToB3d(self.testguy, "weaponback")
					self.melee_armed = False
					self.testguy.playAnim("unback")
				else:
					self.player_state = model_state.unslinging
					self.melee.attachToB3d(self.testguy, "weapon")
					self.melee_armed = True
					self.testguy.playAnim("unback")
		elif(self.player_state == model_state.unslinging):
			if(self.testguy.isAnimDone()):
				if(self.melee_armed):
					self.player_state = model_state.idle
					self.testguy.loopAnim("idle")
				else:
					self.player_state = model_state.holstering
					self.testguy.playAnim("holster")
					
					

		if(self.player_state == model_state.walking):
			travel_vec = self.walking_target - self.location
			travel_length = travel_vec.getLength()
			if(travel_length < self.walking_speed * 1.5):
				self.player_state = model_state.idle
				self.location = self.walking_target
				self.testguy.loopAnim("idle")
			else:
				travel_vec.setLength(self.walking_speed)
				self.location += travel_vec
		self.location.Z = 0
		self.testguy.setLocation(self.location)
		self.testguy.setRotation(self.rotation)
		self.wallCollisions()
		#health packs
		hp_to_remove = []
		for health in self.health_packs:
			if(health.getLocation().getDistanceFrom(self.location) < (self.radius + 10)):
				self.hitpoints += 100
				self.powerup.play()
				if(self.hitpoints > 1000):
					self.hitpoints = 1000
				health.remove()
				#self.health_packs.remove(health) #TODO: fix this
				hp_to_remove.insert(0, self.health_packs.index(health))
		for h in hp_to_remove:
			self.health_packs.pop(h)
		
		mw_to_remove = []
		for m_weapon in self.melee_weapons:
			if(m_weapon.model.getLocation().getDistanceFrom(self.location) < (self.radius + 15)):
				if(self.melee == None or ( self.melee_damage < m_weapon.damage) ):
					if(self.melee != None):
						self.melee.remove()
					self.melee = irrthon.model(self.irr, data.get(m_weapon.filename),4)
					if(self.melee_armed):
						self.melee.attachToB3d(self.testguy, "weapon")
					else:
						self.melee.attachToB3d(self.testguy, "weaponback")
					self.melee_damage = m_weapon.damage
					m_weapon.model.remove()
					#self.melee_weapons.remove(m_weapon) #TODO: fix this
					mw_to_remove.insert(0,self.melee_weapons.index(m_weapon))
		for m in mw_to_remove:
			self.melee_weapons.pop(m)
					
		if(self.coord.X == self.arch_coord.X and self.coord.Y == self.arch_coord.Y):
			self.next_level()
		
		
	def updateRobots(self):
		for robot in self.robots:
			if(robot.awake == False):
				if(robot.location.getDistanceFromSQ(self.location) < robot.wake_dist2):
					robot.awake = True
					robot.state = model_state.walking
					robot.model.loopAnim("walk")
			if(robot.awake == True):
				if(robot.state == model_state.walking):
					direction = self.location - robot.location
					distance = direction.getLength()
					if(distance < (robot.radius + self.radius + 10)):
						robot.state = model_state.melee
						robot.model.playAnim("attack")					
					else:
						direction.setLength(1.0)
						angle = self.angleFromXY(direction)
						robot.rotation.Z = angle + 90
						robot.model.setRotation(robot.rotation)
						direction.setLength(robot.speed * (60.0/self.fps))
						robot.setPosition(robot.getPosition() + direction)
				elif(robot.state == model_state.melee):
					if(robot.model.isAnimHalfDone()):
						#check for player collision
						direction = self.location - robot.location
						distance = direction.getLength()
						if(distance < (robot.radius + self.radius + 10)):
							self.hitpoints -= robot.robot_def[4]
							self.punch.play()
						robot.state = model_state.finishing
				elif(robot.state == model_state.finishing):
					if(robot.model.isAnimDone()):
						robot.state = model_state.walking
						robot.model.loopAnim("walk")
					
			#collisions
			for other_bot in self.robots:
				if(other_bot != robot):
					diff = robot.getPosition() - other_bot.getPosition()
					dist = diff.getLength()
					if(dist < robot.radius + other_bot.radius):
						push_dist = robot.radius + other_bot.radius - dist
						diff.setLength(push_dist)
						robot.setPosition(robot.getPosition() + diff)
			diff = robot.getPosition() - self.location
			dist = diff.getLength()
			if(dist < robot.radius + self.radius):
				push_dist = robot.radius + self.radius - dist
				diff.setLength(push_dist)
				robot.setPosition(robot.getPosition() + diff)
			self.doWalls(robot)
			# TODO: test for death, destroy!
			r_to_remove = []
			if(robot.hitpoints <= 0):
				if(self.rand.randint(0,9)==0):
					#generate melee weapon
					model_filename = robot.robot_def[2]
					if(model_filename != None):
						model = irrthon.model(self.irr, data.get(model_filename), 4)
						model.setLocation(robot.getPosition())
						model.setRotation(irrthon.vector3df(90,0,0))
						m_weapon = melee_weapon_def(model, model_filename, robot.robot_def[5])
						self.melee_weapons.append(m_weapon)
				robot.model.remove()
				#self.robots.remove(robot) #TODO: fix this
				r_to_remove.insert(0, self.robots.index(robot))
			for r in r_to_remove:
				self.robots.pop(r)
				
	
	def wallCollisions(self):
		#north wall
		if(self.map_.getTileType(self.coord.X, self.coord.Y - 1) == gamemap.tile_type.closed):
			wall = (self.coord.Y - 0.5) * self.tile_size
			if(self.location.Y - self.radius < wall):
				self.location.Y = wall + self.radius
		#south wall
		if(self.map_.getTileType(self.coord.X, self.coord.Y + 1) == gamemap.tile_type.closed):
			wall = (self.coord.Y + 0.5) * self.tile_size
			if(self.location.Y + self.radius > wall):
				self.location.Y = wall - self.radius
		#west wall
		if(self.map_.getTileType(self.coord.X - 1, self.coord.Y) == gamemap.tile_type.closed):
			wall = (self.coord.X - 0.5) * self.tile_size
			if(self.location.X - self.radius < wall):
				self.location.X = wall + self.radius
		#east wall
		if(self.map_.getTileType(self.coord.X + 1, self.coord.Y) == gamemap.tile_type.closed):
			wall = (self.coord.X + 0.5) * self.tile_size
			if(self.location.X + self.radius > wall):
				self.location.X = wall - self.radius
				
	def doWalls(self, robot):
		robot.coord.X = int((robot.location.X + (self.tile_size / 2.0)) / self.tile_size)
		robot.coord.Y = int((robot.location.Y + (self.tile_size / 2.0)) / self.tile_size)
		location = robot.getPosition()
		#north wall
		if(self.map_.getTileType(robot.coord.X, robot.coord.Y - 1) == gamemap.tile_type.closed):
			wall = (robot.coord.Y - 0.5) * self.tile_size
			if(location.Y - robot.radius < wall):
				location.Y = wall + robot.radius
		#south wall
		if(self.map_.getTileType(robot.coord.X, robot.coord.Y + 1) == gamemap.tile_type.closed):
			wall = (robot.coord.Y + 0.5) * self.tile_size
			if(location.Y + robot.radius > wall):
				location.Y = wall - robot.radius
		#west wall
		if(self.map_.getTileType(robot.coord.X - 1, robot.coord.Y) == gamemap.tile_type.closed):
			wall = (robot.coord.X - 0.5) * self.tile_size
			if(location.X - robot.radius < wall):
				location.X = wall + robot.radius
		#east wall
		if(self.map_.getTileType(robot.coord.X + 1, robot.coord.Y) == gamemap.tile_type.closed):
			wall = (robot.coord.X + 0.5) * self.tile_size
			if(location.X + robot.radius > wall):
				location.X = wall - robot.radius
		robot.setPosition(location)
				
	